/**
 * adapter for mobile and desktop events
 */
import { UserInputEvent } from '../types';
import detectMobile from '../util/is.mobile';
export default () => {
    const isMobile = detectMobile(window.navigator.userAgent);
    const interaction = {
        PointerEnd: isMobile ? UserInputEvent.touchend : UserInputEvent.mouseup,
        PointerTap: isMobile ? UserInputEvent.touchstart : UserInputEvent.click,
        // hover and click will be the same event in mobile
        PointerOver: isMobile ? UserInputEvent.touchstart : UserInputEvent.mouseover,
    };
    return interaction;
};
//# sourceMappingURL=interaction.js.map